; AutoIt Version: 3.3.0
; Language:       English
; Platform:       Win9x/NT
; Author:         yannis kargas
; Script Function:   exits/restarts km with symbitoic loader to enforce prefs change
;
#NoTrayIcon

$kmexe=(@scriptdir & "\k-meleon.exe")
If FileExists($kmexe) Then
proceed()
Else
MsgBox(48, "Use Error", "Can't resume. Make sure kmsuperexit.exe in the same folder as k-meleon.exe")
EndIf

Func proceed()
if $CmdLine[0]=0 Then
MsgBox(48, "Use Error", "You can only run this tool from kmeleon's file menu.")
Exit
ElseIf $CmdLine[0]=1 Then
exitkm()
else
restartkm()
EndIf
EndFunc

Func restartkm()
$kmLoader=(@scriptdir & "\loader.exe")
$kmexe=(@scriptdir & "\k-meleon.exe")
$prefspath=($CmdLine[1] & "\prefs.js")
$cleanclose=("user_pref" & "(" &"""" & "kmeleon.plugins.sessions.cleanShutdown" & """" & "," & " true" & ");")
While WinExists("[CLASS:KMeleon Browser Window]", "")
          WinClose("[CLASS:KMeleon Browser Window]", "");
          sleep(400);
              If WinActive("K-Meleon") Then
              Send("{Enter}")
              EndIf
Wend
sleep(400)
ProcessClose("loader.exe")
sleep(44)
ProcessClose("k-meleon.exe")
sleep(88)
FileWriteLine($prefspath, $cleanclose)
sleep(88)
Run($kmexe)
sleep(4888)
Run($kmLoader)
EndFunc

Func exitkm()
$kmLoader=(@scriptdir & "\loader.exe")
$prefspath=($CmdLine[1] & "\prefs.js")
$cleanclose=("user_pref" & "(" &"""" & "kmeleon.plugins.sessions.cleanShutdown" & """" & "," & " true" & ");")
While WinExists("[CLASS:KMeleon Browser Window]", "")
          WinClose("[CLASS:KMeleon Browser Window]", "");
          sleep(400);
              If WinActive("K-Meleon") Then
              Send("{Enter}")
              EndIf
Wend
sleep(400)
ProcessClose("loader.exe")
sleep(44)
ProcessClose("k-meleon.exe")
sleep(88)
FileWriteLine($prefspath, $cleanclose)
sleep(22)
Run($kmLoader)
EndFunc

$fred = _RefreshSystemTray(1000)
Func _RefreshSystemTray($nDelay = 1000)
; Save Opt settings
     Local $oldMatchMode = Opt("WinTitleMatchMode", 4)
     Local $oldChildMode = Opt("WinSearchChildren", 1)
     Local $error = 0
     Do; Pseudo loop
         Local $hWnd = WinGetHandle("classname=TrayNotifyWnd")
         If @error Then
             $error = 1
             ExitLoop
         EndIf

         Local $hControl = ControlGetHandle($hWnd, "", "Button1")
        
     ; We're on XP and the Hide Inactive Icons button is there, so expand it
         If $hControl <> "" And ControlCommand($hWnd, "", $hControl, "IsVisible") Then
             ControlClick($hWnd, "", $hControl)
             Sleep($nDelay)
         EndIf
        
         Local $posStart = MouseGetPos()
         Local $posWin = WinGetPos($hWnd)    
        
         Local $y = $posWin[1]
         While $y < $posWin[3] + $posWin[1]
             Local $x = $posWin[0]
             While $x < $posWin[2] + $posWin[0]
                 DllCall("user32.dll", "int", "SetCursorPos", "int", $x, "int", $y)
                 If @error Then
                     $error = 2
                     ExitLoop 3; Jump out of While/While/Do
                 EndIf
                 $x = $x + 8
             WEnd
             $y = $y + 8
         WEnd
         DllCall("user32.dll", "int", "SetCursorPos", "int", $posStart[0], "int", $posStart[1])
     ; We're on XP so we need to hide the inactive icons again.
         If $hControl <> "" And ControlCommand($hWnd, "", $hControl, "IsVisible") Then
             ControlClick($hWnd, "", $hControl)
         EndIf
     Until 1
    
; Restore Opt settings
     Opt("WinTitleMatchMode", $oldMatchMode)
     Opt("WinSearchChildren", $oldChildMode)
     SetError($error)
EndFunc; _RefreshSystemTray()
